Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/PluginStoreTest.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/PluginStoreTest.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/PluginStoreTest.cs	(revision 2771)
@@ -72,5 +72,5 @@
       int oldCount = target.Plugins.Count();
       // store a new entry in the db
-      string name = Guid.NewGuid().ToString();
+      string name = RandomName();
       target.Persist(new PluginDescription(name, new Version(0, 1)), enc.GetBytes("Zipped " + name));
       int newCount = target.Plugins.Count();
@@ -100,5 +100,5 @@
       #region persist single plugin without dependencies
       {
-        string name = Guid.NewGuid().ToString();
+        string name = RandomName();
         int oldCount = target.Plugins.Count();
         PluginDescription pluginDescription = new PluginDescription(name, vers01);
@@ -112,5 +112,5 @@
       #region persist a product with same name and version as an existent product
       {
-        string name = Guid.NewGuid().ToString();
+        string name = RandomName();
         int oldCount = target.Plugins.Count();
         PluginDescription pluginDescription = new PluginDescription(name, vers01);
@@ -142,5 +142,5 @@
       #region persist a plugin with an already persisted dependency
       {
-        string name = Guid.NewGuid().ToString();
+        string name = RandomName();
         PluginDescription dependency = new PluginDescription(name, vers01);
         // insert dependency first
@@ -148,5 +148,5 @@
 
         // persist another plugin that has a dependency on the first plugin
-        string name2 = Guid.NewGuid().ToString();
+        string name2 = RandomName();
         int oldCount = target.Plugins.Count();
 
@@ -168,6 +168,6 @@
         // try to persist a new plugin with a non-existant dependency
         try {
-          string pluginName = Guid.NewGuid().ToString();
-          string dependencyName = Guid.NewGuid().ToString();
+          string pluginName = RandomName();
+          string dependencyName = RandomName();
           var dependency = new PluginDescription(dependencyName, vers01);
           var newEntity = new PluginDescription(pluginName, vers01, Enumerable.Repeat(dependency, 1));
@@ -185,5 +185,5 @@
       {
         // insert new plugin
-        string pluginName = Guid.NewGuid().ToString();
+        string pluginName = RandomName();
         var newPlugin = new PluginDescription(pluginName, vers01);
         target.Persist(newPlugin, enc.GetBytes("Zipped " + pluginName));
@@ -204,9 +204,9 @@
       #region update the dependencies of an existing plugin
       {
-        string dependency1Name = Guid.NewGuid().ToString();
+        string dependency1Name = RandomName();
         var newDependency1 = new PluginDescription(dependency1Name, vers01);
         target.Persist(newDependency1, enc.GetBytes("Zipped " + dependency1Name));
 
-        string pluginName = Guid.NewGuid().ToString();
+        string pluginName = RandomName();
         var newPlugin = new PluginDescription(pluginName, vers01, Enumerable.Repeat(newDependency1, 1));
         target.Persist(newPlugin, enc.GetBytes("Zipped " + pluginName));
@@ -218,5 +218,5 @@
 
         // change dependencies 
-        string dependency2Name = Guid.NewGuid().ToString();
+        string dependency2Name = RandomName();
         var newDependency2 = new PluginDescription(dependency2Name, vers01);
         target.Persist(newDependency2, enc.GetBytes("Zipped " + pluginName));
@@ -232,10 +232,10 @@
       #region try to insert a plugin that references the same dependency twice and check if the correct exception is thrown
       {
-        string depName = Guid.NewGuid().ToString();
+        string depName = RandomName();
         var depPlugin = new PluginDescription(depName, vers01);
         target.Persist(depPlugin, enc.GetBytes("Zipped " + depName));
 
         // insert new plugin
-        string pluginName = Guid.NewGuid().ToString();
+        string pluginName = RandomName();
         var plugin = new PluginDescription(pluginName, vers01, new PluginDescription[] { depPlugin, depPlugin });
         try {
@@ -248,4 +248,23 @@
       }
       #endregion
+
+      #region try to insert a plugin that with a cyclic reference
+      {
+        string depName = RandomName();
+        var depPlugin = new PluginDescription(depName, vers01);
+        target.Persist(depPlugin, enc.GetBytes("Zipped " + depName));
+
+        // update the plugin so that it has a dependency on itself 
+        var plugin = new PluginDescription(depName, vers01, new PluginDescription[] { depPlugin });
+        try {
+          target.Persist(plugin, enc.GetBytes("Zipped " + depName));
+          Assert.Fail("Expected ArgumentException");
+        }
+        catch (ArgumentException) {
+          Assert.IsTrue(true, "Exception thrown as expected");
+        }
+      }
+      #endregion
+
     }
 
@@ -260,5 +279,5 @@
       #region persist a product without plugins to the db
       {
-        string prodName = Guid.NewGuid().ToString();
+        string prodName = RandomName();
         int oldCount = target.Products.Count();
         ProductDescription product = new ProductDescription(prodName, vers01);
@@ -271,5 +290,5 @@
       #region persist a product with the same name and version as an existant product
       {
-        string prodName = Guid.NewGuid().ToString();
+        string prodName = RandomName();
         int oldCount = target.Products.Count();
         ProductDescription product = new ProductDescription(prodName, vers01);
@@ -300,7 +319,7 @@
       #region try to persist a product referencing an non-existant plugin and check the expected exception
       {
-        // try to persist a product referencing an non-existant plugin
-        string prodName = Guid.NewGuid().ToString();
-        string pluginName = Guid.NewGuid().ToString();
+        // try to persist a product referencing a non-existant plugin
+        string prodName = RandomName();
+        string pluginName = RandomName();
         var plugin = new PluginDescription(pluginName, vers01);
         var product = new ProductDescription(prodName, vers01, Enumerable.Repeat(plugin, 1));
@@ -318,6 +337,6 @@
       #region persist a product with a single plugin reference
       {
-        string prodName = Guid.NewGuid().ToString();
-        string pluginName = Guid.NewGuid().ToString();
+        string prodName = RandomName();
+        string pluginName = RandomName();
         var plugin = new PluginDescription(pluginName, vers01);
         var product = new ProductDescription(prodName, vers01, Enumerable.Repeat(plugin, 1));
@@ -339,6 +358,6 @@
       #region update the plugin list of an existing product
       {
-        string prodName = Guid.NewGuid().ToString();
-        string plugin1Name = Guid.NewGuid().ToString();
+        string prodName = RandomName();
+        string plugin1Name = RandomName();
         var plugin1 = new PluginDescription(plugin1Name, vers01);
         var product = new ProductDescription(prodName, vers01, Enumerable.Repeat(plugin1, 1));
@@ -352,5 +371,5 @@
         Assert.AreEqual(oldCount + 1, newCount);
 
-        var plugin2Name = Guid.NewGuid().ToString();
+        var plugin2Name = RandomName();
         var plugin2 = new PluginDescription(plugin2Name, vers01);
         target.Persist(plugin2, enc.GetBytes("Zipped " + plugin2.Name));
@@ -370,6 +389,6 @@
       #region insert a product which references the same plugin twice and check if the correct exception is thrown
       {
-        string prodName = Guid.NewGuid().ToString();
-        string plugin1Name = Guid.NewGuid().ToString();
+        string prodName = RandomName();
+        string plugin1Name = RandomName();
         var plugin1 = new PluginDescription(plugin1Name, vers01);
         var product = new ProductDescription(prodName, vers01, Enumerable.Repeat(plugin1, 2));
@@ -406,5 +425,5 @@
       List<PluginDescription> plugins = new List<PluginDescription>();
       for (int i = 0; i < nPlugins; i++) {
-        string name = Guid.NewGuid().ToString();
+        string name = RandomName();
         var dependencies = store.Plugins;
         if (dependencies.Count() > maxDependencies) dependencies = dependencies.Take(maxDependencies);
@@ -430,8 +449,9 @@
       // create products
       for (int i = 0; i < nProducts; i++) {
-        string name = Guid.NewGuid().ToString();
+        string name = RandomName();
         List<PluginDescription> prodPlugins = new List<PluginDescription>();
         for (int j = 0; j < avgProductPlugins; j++) {
-          prodPlugins.Add(plugins[r.Next(0, plugins.Count)]);
+          var selectedPlugin = plugins[r.Next(0, plugins.Count)];
+          if (!prodPlugins.Contains(selectedPlugin)) prodPlugins.Add(selectedPlugin);
         }
         var prod = new ProductDescription(name, vers01, prodPlugins);
@@ -442,4 +462,8 @@
         " ms (" + (double)stopWatch.ElapsedMilliseconds / nProducts + " ms / product )");
     }
+
+    private string RandomName() {
+      return Guid.NewGuid().ToString();
+    }
   }
 }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/HeuristicLab.Services.Deployment.DataAccess.xsd
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/HeuristicLab.Services.Deployment.DataAccess.xsd	(revision 2771)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/HeuristicLab.Services.Deployment.DataAccess.xsd	(revision 2771)
@@ -0,0 +1,28 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<xs:schema xmlns:tns="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Deployment.DataAccess" elementFormDefault="qualified" targetNamespace="http://schemas.datacontract.org/2004/07/HeuristicLab.Services.Deployment.DataAccess" xmlns:xs="http://www.w3.org/2001/XMLSchema">
+  <xs:import namespace="http://schemas.datacontract.org/2004/07/System" />
+  <xs:complexType name="ProductDescription">
+    <xs:sequence>
+      <xs:element minOccurs="0" name="Id" type="xs:long" />
+      <xs:element minOccurs="0" name="Name" nillable="true" type="xs:string" />
+      <xs:element minOccurs="0" name="Plugins" nillable="true" type="tns:ArrayOfPluginDescription" />
+      <xs:element xmlns:q1="http://schemas.datacontract.org/2004/07/System" minOccurs="0" name="Version" nillable="true" type="q1:Version" />
+    </xs:sequence>
+  </xs:complexType>
+  <xs:element name="ProductDescription" nillable="true" type="tns:ProductDescription" />
+  <xs:complexType name="ArrayOfPluginDescription">
+    <xs:sequence>
+      <xs:element minOccurs="0" maxOccurs="unbounded" name="PluginDescription" nillable="true" type="tns:PluginDescription" />
+    </xs:sequence>
+  </xs:complexType>
+  <xs:element name="ArrayOfPluginDescription" nillable="true" type="tns:ArrayOfPluginDescription" />
+  <xs:complexType name="PluginDescription">
+    <xs:sequence>
+      <xs:element minOccurs="0" name="Dependencies" nillable="true" type="tns:ArrayOfPluginDescription" />
+      <xs:element minOccurs="0" name="Id" type="xs:long" />
+      <xs:element minOccurs="0" name="Name" nillable="true" type="xs:string" />
+      <xs:element xmlns:q2="http://schemas.datacontract.org/2004/07/System" minOccurs="0" name="Version" nillable="true" type="q2:Version" />
+    </xs:sequence>
+  </xs:complexType>
+  <xs:element name="PluginDescription" nillable="true" type="tns:PluginDescription" />
+</xs:schema>
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/Reference.svcmap
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/Reference.svcmap	(revision 2771)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/Reference.svcmap	(revision 2771)
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="utf-8"?>
+<ReferenceGroup xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" ID="e652d6cb-b9e4-4a0e-9b49-2160c4b40e1d" xmlns="urn:schemas-microsoft-com:xml-wcfservicemap">
+  <ClientOptions>
+    <GenerateAsynchronousMethods>false</GenerateAsynchronousMethods>
+    <EnableDataBinding>true</EnableDataBinding>
+    <ExcludedTypes />
+    <ImportXmlTypes>false</ImportXmlTypes>
+    <GenerateInternalTypes>false</GenerateInternalTypes>
+    <GenerateMessageContracts>false</GenerateMessageContracts>
+    <NamespaceMappings />
+    <CollectionMappings />
+    <GenerateSerializableTypes>true</GenerateSerializableTypes>
+    <Serializer>Auto</Serializer>
+    <ReferenceAllAssemblies>true</ReferenceAllAssemblies>
+    <ReferencedAssemblies />
+    <ReferencedDataContractTypes />
+    <ServiceContractMappings />
+  </ClientOptions>
+  <MetadataSources>
+    <MetadataSource Address="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" Protocol="mex" SourceId="1" />
+  </MetadataSources>
+  <Metadata>
+    <MetadataFile FileName="service.wsdl" MetadataType="Wsdl" ID="f9aa7841-9f78-43d9-9008-0decd3d12993" SourceId="1" SourceUrl="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" />
+    <MetadataFile FileName="service.xsd" MetadataType="Schema" ID="c0d733c0-fa7a-4965-bf67-e04efdf79732" SourceId="1" SourceUrl="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" />
+    <MetadataFile FileName="service1.xsd" MetadataType="Schema" ID="8b323fa0-af4b-4db2-95c7-caf4621ded43" SourceId="1" SourceUrl="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" />
+    <MetadataFile FileName="HeuristicLab.Services.Deployment.DataAccess.xsd" MetadataType="Schema" ID="a04dde5e-6016-4f53-bdcc-3dc30e4867d7" SourceId="1" SourceUrl="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" />
+    <MetadataFile FileName="System.xsd" MetadataType="Schema" ID="de5b0b79-4ace-49d6-9d08-a352d353beef" SourceId="1" SourceUrl="http://localhost:8731/Design_Time_Addresses/HeuristicLab.Services.Deployment/Admin/mex" />
+  </Metadata>
+  <Extensions>
+    <ExtensionFile FileName="configuration91.svcinfo" Name="configuration91.svcinfo" />
+    <ExtensionFile FileName="configuration.svcinfo" Name="configuration.svcinfo" />
+  </Extensions>
+</ReferenceGroup>
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/System.xsd
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/System.xsd	(revision 2771)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment.Test/Service References/AdminService/System.xsd	(revision 2771)
@@ -0,0 +1,12 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<xs:schema xmlns:tns="http://schemas.datacontract.org/2004/07/System" elementFormDefault="qualified" targetNamespace="http://schemas.datacontract.org/2004/07/System" xmlns:xs="http://www.w3.org/2001/XMLSchema">
+  <xs:complexType name="Version">
+    <xs:sequence>
+      <xs:element name="_Build" type="xs:int" />
+      <xs:element name="_Major" type="xs:int" />
+      <xs:element name="_Minor" type="xs:int" />
+      <xs:element name="_Revision" type="xs:int" />
+    </xs:sequence>
+  </xs:complexType>
+  <xs:element name="Version" nillable="true" type="tns:Version" />
+</xs:schema>
